// compile: gcc -o haraka_interface haraka.c hash_haraka.c utils.c address.c haraka_interface.c
// run: ./haraka_interface R pk m (arguments in hex)
#include <stdint.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "./address.h"
#include "./utils.h"
#include "./params.h" // change the link to the ctf one
#include "./hash.h"
#include "./haraka.h"

unsigned char* hexstr_to_char(const char* hexstr)
{
    size_t len = strlen(hexstr);
    size_t final_len = len / 2;
    unsigned char* chrs = (unsigned char*)malloc((final_len) * sizeof(*chrs)*10);
    for (size_t i=0, j=0; j<final_len; i+=2, j++)
        chrs[j] = (hexstr[i] % 32 + 9) % 25 * 16 + (hexstr[i+1] % 32 + 9) % 25;
    return chrs;
}

int main(int argc, char** argv)
{
    unsigned char mhash[SPX_FORS_MSG_BYTES];
    uint64_t tree;
    uint32_t idx_leaf;

    //assert(argc == 4);

    unsigned char* R  = hexstr_to_char(argv[1]);
    unsigned char* pk = hexstr_to_char(argv[2]);
    unsigned char* m  = hexstr_to_char(argv[3]);
    unsigned long long mlen = strlen(m);
    unsigned long long Rlen = strlen(R);

    //assert(Rlen == 8);
    //assert(mlen > 0);

    initialize_hash_function(pk, NULL);
    hash_message(mhash, &tree, &idx_leaf, R, pk, m, mlen);

    printf("mhash = ");
    for(int i = 0; i < SPX_FORS_MSG_BYTES; i++){
        printf("%02x", mhash[i]);
    }
    printf("\n");

    printf("(tree_idx, leaf_idx) = (%lu, %u)\n", tree, idx_leaf);

    return 0;
}
